# coding: utf-8

"""
    DLCM-Solution

    DLCM application wrapping all modules, All-In-One  # noqa: E501

    The version of the OpenAPI document: 2.1.1
    Contact: eresearch-opensource@unige.ch
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from dlcmapi_client.configuration import Configuration


class Page(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'current_page': 'float',
        'size_page': 'float',
        'total_items': 'float',
        'total_pages': 'float'
    }

    attribute_map = {
        'current_page': 'currentPage',
        'size_page': 'sizePage',
        'total_items': 'totalItems',
        'total_pages': 'totalPages'
    }

    def __init__(self, current_page=None, size_page=None, total_items=None, total_pages=None, local_vars_configuration=None):  # noqa: E501
        """Page - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._current_page = None
        self._size_page = None
        self._total_items = None
        self._total_pages = None
        self.discriminator = None

        if current_page is not None:
            self.current_page = current_page
        if size_page is not None:
            self.size_page = size_page
        if total_items is not None:
            self.total_items = total_items
        if total_pages is not None:
            self.total_pages = total_pages

    @property
    def current_page(self):
        """Gets the current_page of this Page.  # noqa: E501

        The current page number  # noqa: E501

        :return: The current_page of this Page.  # noqa: E501
        :rtype: float
        """
        return self._current_page

    @current_page.setter
    def current_page(self, current_page):
        """Sets the current_page of this Page.

        The current page number  # noqa: E501

        :param current_page: The current_page of this Page.  # noqa: E501
        :type: float
        """

        self._current_page = current_page

    @property
    def size_page(self):
        """Gets the size_page of this Page.  # noqa: E501

        The number of item per page  # noqa: E501

        :return: The size_page of this Page.  # noqa: E501
        :rtype: float
        """
        return self._size_page

    @size_page.setter
    def size_page(self, size_page):
        """Sets the size_page of this Page.

        The number of item per page  # noqa: E501

        :param size_page: The size_page of this Page.  # noqa: E501
        :type: float
        """

        self._size_page = size_page

    @property
    def total_items(self):
        """Gets the total_items of this Page.  # noqa: E501

        The total number of items  # noqa: E501

        :return: The total_items of this Page.  # noqa: E501
        :rtype: float
        """
        return self._total_items

    @total_items.setter
    def total_items(self, total_items):
        """Sets the total_items of this Page.

        The total number of items  # noqa: E501

        :param total_items: The total_items of this Page.  # noqa: E501
        :type: float
        """

        self._total_items = total_items

    @property
    def total_pages(self):
        """Gets the total_pages of this Page.  # noqa: E501

        The total number of page  # noqa: E501

        :return: The total_pages of this Page.  # noqa: E501
        :rtype: float
        """
        return self._total_pages

    @total_pages.setter
    def total_pages(self, total_pages):
        """Sets the total_pages of this Page.

        The total number of page  # noqa: E501

        :param total_pages: The total_pages of this Page.  # noqa: E501
        :type: float
        """

        self._total_pages = total_pages

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, Page):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, Page):
            return True

        return self.to_dict() != other.to_dict()
